# Move a circle to the position clicked by the user 5 times
# by CSCI 111, 01.25.2012

from graphics import *

CIRCLE_RADIUS = 50

win = GraphWin("Circle Shift", 500, 500)

# Give instructions to the user
anchorPoint = Point(win.getWidth()/2, 10)
instruction = Text(anchorPoint, "Click where you want your circle to go.")
instruction.draw(win)

# create the initial circle in the center of the window and draw it
midPoint = Point(win.getWidth()/2, win.getHeight()/2)
circle = Circle( midPoint, CIRCLE_RADIUS)
circle.draw(win)

# repeat a certain number of times
for x in range(5):
    # where the user clicked, i.e., where the user wants to put the circle
    destination = win.getMouse()
    
    # determine the distance between the current center of the circle
    # and the destination
    dx = destination.getX() - midPoint.getX() 
    ycoord = destination.getY()
    dy = ycoord - midPoint.getY()
    
    # move the circle the distance computed above
    circle.move(dx, dy)
    
    # set the midpoint of the circle to the destination
    # (now the center of the circle)
    midPoint = destination
    
# update the user's instructions
instruction.setText("Click to close")

win.getMouse()
win.close()
