# Given a file containing students names and their years (freshman, sophomore,
# junior, or senior) for this class, creates a report (in a file) that
# says the year and how many students from that year are in this class, on the
# same line.
#
# CSCI 111, 02.27.2012

FILENAME="data/years.dat"
REPORTNAME="data/report.dat"

def numLinesOccursOn(searchTerm, filename):
    """
    returns an integer representing the count of the number of lines the
    searchTerm occurs in the file
    
    Parameters:
        searchTerm - a string representing what to search for
        filename - the name of the file to search
    """
    
    # open the file in read mode
    dataFile = open(filename, "r")
    
    linesFound = 0
    # Read through each line in the file
    for line in dataFile:
        # figure out if the search term is in the line
        if searchTerm in line:
            linesFound += 1
      
    dataFile.close()
    return linesFound

searchTerms = ["FY", "SO", "JR", "SR" ]

reportFile = open(REPORTNAME, "w")

for searchTerm in searchTerms:
    numLines = numLinesOccursOn(searchTerm, FILENAME)
    reportFile.write("%2s %3d\n" % (searchTerm, numLines))
        
reportFile.close()
