# Caesar Cipher
# Given a key and a phrase, converts the phrase to lower case letters
# and encodes the phrase using the Caesar Cipher--shifting characters

import sys

DATA_DIR = "data/"

KEY_BOUND=25
MIN_ASCII=ord('a')
MAX_ASCII=ord('z')
ASCII_SHIFT = 26

print("This program encodes and decodes Caesar ciphers\n")

# get user input
inputFileName = input("Enter the name of a file to encode (in " + DATA_DIR + "): ")
key = eval(input("Enter the encoder key (an integer between -25 and 25): "))
outputFileName = input("Enter the name of the output file: ")


# make sure the key is valid
if key < -KEY_BOUND or key > KEY_BOUND:
    print("Invalid key!")
    sys.exit(1)


# open the input and output files
inputFile = open(DATA_DIR + inputFileName, "r")
outputFile = open(DATA_DIR + outputFileName, "w")

# read each line from the input file, encode the line, and write the
# encoded message to a file
for line in inputFile:

    # get rid of the new line at the end of the line
    line = line.rstrip()
    # make sure the user's message is all lower case
    line = line.lower()

    # An accumulator for the encoded message
    encodedMsg = ""

    # Go through the userMessage, add the new rep of each char to encodedMsg
    for char in line:
        # Spaces should stay spaces
        if char == " ":
            newChar = " "
        # if it's not a space, we assume it's a lowercase letter
        else:
            # The ASCII rep of the encoded char is the ASCII rep of the
            # old one plus key
            newOrdVal = ord(char) + key

            # handle if new value is out of range
            if newOrdVal < MIN_ASCII:
                newOrdVal += ASCII_SHIFT
            elif newOrdVal > MAX_ASCII:
                newOrdVal -= ASCII_SHIFT
            newChar = chr(newOrdVal)
        encodedMsg += newChar

    outputFile.write(encodedMsg + "\n")
    print(encodedMsg)

inputFile.close()
outputFile.close()

print("Saved encoded message to", DATA_DIR + outputFileName)

